Subject: [bug#59989] [PATCH] tests: Fix txinfo-include test for texinfo 7.x

From: Gavin Smith <[email-masked]>
Date: Wed, 14 Dec 2022 08:13:55 +0000

On Mon, Dec 12, 2022 at 07:28:38AM +0100, Frederic Berat wrote:
> From: Frédéric Bérat <[email-masked]>
> 
> Texinfo modified its behavior regarding apostrophes, which are now
> replaced by UTF-8 right single quotes by default.
> It looks like this was supposed to be the default for few years already,
> but this behavior was broken so far.
> 
> Use the @verb construct in order to ensure that the quotes are kept
> has-is, so that we can easily grep for "GNU's Not Unix".

The change affected the output when a @documentencoding directive was
not present in the Texinfo file.  The curly quotes were used from
Texinfo 5.0 onwards I believe (the big Perl rewrite from 2013) if
"@documentencoding UTF-8" was specified.  Later (2019) UTF-8 was made the
default encoding for input files but the curly quotes were not used
in the output unless there was an explicit @documentencoding directive.
This was not documented well and users found it confusing, and in the latest
release, it makes no difference whether the directive is present.
These non-ASCII characters are on by default and turned off by passing
"-c ASCII_PUNCTUATION=0" on the texi2any command line.

I think using curly quotes by default was a mistake in the first place
for UTF-8 input; however, any changes to the defaults should be discussed
on [email-masked].  The main issue that I would foresee is that
in Emacs Info mode, there can be highlighting of text surrounded by
curly quotes, so we would have to check that this highlighting also
worked if ASCII apostrophes were used instead.

One option would be to carry on using ‘ and ’ for the output of @code etc.,
but not for where literal ` and ' appeared in the Texinfo source.  Likewise
for “ and ” and `` and ''.  This would mean you could easily search for
words like "Don't" in the Info browser.